# Variation Distribution

When running an A/B Test, you need to assign users to Variations and implement logic for each Variation. You can use the Hackle SDK to handle this user distribution.

{% hint style="warning" %}
Unity SDK is built on top of Android and iOS SDKs.\
In Unity Editor, all calls return Group A.
{% endhint %}

## variation

Pass the **Experiment Key** to the `Variation()` method to assign users to a Variation and receive the result. Then implement logic for each Variation.

In the example code below, Experiment Key 42 is passed, and there are two Variations: A and B.

```csharp
// Determines which Variation to show to the user in the A/B Test with Experiment Key 42.
// Returns Variation A if a decision cannot be made.
string variation = hackle.Variation(42);

// Logic for the assigned Variation
if (variation == "A") {
  // Group A logic
} else if (variation == "B") {
  // Group B logic
}
```

## variationDetail

The `VariationDetail()` method works the same as `Variation()` but additionally provides the reason for being assigned to a specific group. This method is useful for verifying that distribution is working correctly.\
You must pass the Experiment Key as a parameter. In the example code below, Experiment Key 42 is passed.

```csharp
// Variation distribution decision detail
HackleDecision decision = hackle.VariationDetail(42);

// Assigned Variation
string variation = decision.variation;

// Decision reason
string reason = decision.reason;
```

The decision reason is returned in a format such as **`SDK_NOT_READY`**. Refer to the table below for details.

<table><thead><tr><th width="319.12109375">Distribution Reason</th><th width="305.35546875">Description</th><th>Distribution Result</th></tr></thead><tbody><tr><td><code>SDK_NOT_READY</code></td><td><p>The SDK is not ready to use.</p><p>(e.g., initialization attempted with an invalid SDK Key)</p></td><td>A (Control Group)</td></tr><tr><td><code>EXPERIMENT_NOT_FOUND</code></td><td>No A/B Test was found for the provided Experiment Key. The Experiment Key may be incorrect, or the experiment may be archived.</td><td>A (Control Group)</td></tr><tr><td><code>NOT_IN_MUTUAL_EXCLUSION_EXPERIMENT</code></td><td>The experiment is included in Mutually Exclusive Settings, but<br>the user was not assigned to that Mutually Exclusive Group.</td><td>A (Control Group)</td></tr><tr><td><code>EXPERIMENT_DRAFT</code></td><td>The A/B Test is in draft state.</td><td>A (Control Group)</td></tr><tr><td><code>EXPERIMENT_PAUSED</code></td><td>The A/B Test is paused.</td><td>A (Control Group)</td></tr><tr><td><code>EXPERIMENT_COMPLETED</code></td><td>The A/B Test has ended.</td><td>Winning Variation selected at completion</td></tr><tr><td><code>OVERRIDDEN</code></td><td>The user was assigned to a specific group<br>by Override.</td><td>Override-assigned<br>group</td></tr><tr><td><code>NOT_IN_EXPERIMENT_TARGET</code></td><td>The user is not an A/B Test target.</td><td>A (Control Group)</td></tr><tr><td><code>TRAFFIC_NOT_ALLOCATED</code></td><td>The A/B Test is running, but<br>the user was not allocated to the test.</td><td>A (Control Group)</td></tr><tr><td><code>TRAFFIC_ALLOCATED</code></td><td>The user has been allocated to the A/B Test.</td><td>Allocated group</td></tr><tr><td><code>VARIATION_DROPPED</code></td><td>The originally allocated group has been removed from the test.</td><td>A (Control Group)</td></tr><tr><td><code>INVALID_INPUT</code></td><td>The input value is invalid.</td><td>A (Control Group)</td></tr><tr><td><code>EXCEPTION</code></td><td>An unknown error occurred.</td><td>A (Control Group)</td></tr></tbody></table>

## Parameters

* You can also receive the parameter values for the assigned Variation through the `VariationDetail()` method.
* You can use the `GetBoolean()`, `GetDouble()`, `GetInt()`, `GetLong()`, and `GetString()` methods to retrieve the parameter values configured in the A/B Test screen. If you change values in the A/B Test parameter settings screen, the updated values are applied in the code.
* Since parameter values configured in the Hackle A/B Test screen are stored as key-value pairs, use the methods below according to the parameter type to retrieve the configured values.

### GetString

* Returns parameter values configured as STRING or JSON type.
* Returns the value configured for the assigned Variation.

```csharp
HackleDecision decision = hackle.VariationDetail(42);

string strValue = decsision.GetString("parameter_key_string_type", "defaultValue");
string jsonValue = decsision.GetString("parameter_key_json_type", "{}");
```

### GetInt

* Returns parameter values configured as Number type as an Int.
* Returns the value configured for the assigned Variation.

```csharp
HackleDecision decision = hackle.VariationDetail(42);

int intValue = decsision.GetInt("parameter_key_number_type", 0);
```

### GetDouble

* Returns parameter values configured as Number type as a Double.
* Returns the value configured for the assigned Variation.

```csharp
HackleDecision decision = hackle.VariationDetail(42);

double doubleValue = decsision.GetDouble("parameter_key_number_type", 0.0);
```

### GetLong

* Returns parameter values configured as Number type as a Long.
* Returns the value configured for the assigned Variation.

```csharp
HackleDecision decision = hackle.VariationDetail(42);

long longValue = decsision.GetLong("parameter_key_number_type", 0);
```

### GetBoolean

* Returns parameter values configured as Boolean type.
* Returns the value configured for the assigned Variation.

```csharp
HackleDecision decision = hackle.VariationDetail(42);

bool boolValue = decsision.GetBoolean("parameter_key_boolean_type", false);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hackle.io/en/development-guide/unity/unity-variation.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
